local bs = AceLibrary("Babble-Spell-2.2")
local AceAddon = AceLibrary("AceAddon-2.0")

local L = AceLibrary("AceLocale-2.0"):new("Cartographer_Herbalism")
L:RegisterTranslations("enUS", function() return {
    ["^You perform %s on (.+)%%.$"] = true,

    -- herbs
    ["Silverleaf"] = true,
    ["Peacebloom"] = true,
    ["Mageroyal"] = true,
    ["Bruiseweed"] = true,
    ["Kingsblood"] = true,
    ["Fadeleaf"] = true,
    ["Stranglekelp"] = true,
    ["Liferoot"] = true,
    ["Briarthorn"] = true,
    ["Earthroot"] = true,
    ["Sungrass"] = true,
    ["Blindweed"] = true,
    ["Gromsblood"] = true,
    ["Dreamfoil"] = true,
    ["Firebloom"] = true,
    ["Arthas' Tears"] = true,
    ["Purple Lotus"] = true,
    ["Goldthorn"] = true,
    ["Wildvine"] = true,
    ["Grave Moss"] = true,
    ["Mountain Silversage"] = true,
    ["Black Lotus"] = true,
    ["Ghost Mushroom"] = true,
    ["Golden Sansam"] = true,
    ["Icecap"] = true,
    ["Khadgar's Whisker"] = true,
    ["Plaguebloom"] = true,
    ["Swiftthistle"] = true,
    ["Wild Steelbloom"] = true,
    ["Wintersbite"] = true,
    ["Felweed"] = true,
} end)

local mod = Cartographer:NewModule(bs["Herbalism"], "AceConsole-2.0", "AceEvent-2.0")

mod.icon = {
    ["Black Lotus"] = {
        text = L["Black Lotus"],
        path = "Interface\\Icons\\INV_Misc_Herb_BlackLotus",
        width = 12,
        height = 12
    },
    ["Blindweed"] = {
        text = L["Blindweed"],
        path = "Interface\\Icons\\INV_Misc_Herb_14",
        width = 12,
        height = 12
    },
    ["Briarthorn"] = {
        text = L["Briarthorn"],
        path = "Interface\\Icons\\INV_Misc_Root_01",
        width = 12,
        height = 12
    },
    ["Bruiseweed"] = {
        text = L["Bruiseweed"],
        path = "Interface\\Icons\\INV_Misc_Herb_01",
        width = 12,
        height = 12
    },
    ["Dreamfoil"] = {
        text = L["Dreamfoil"],
        path = "Interface\\Icons\\INV_Misc_Herb_DreamFoil",
        width = 12,
        height = 12
    },
    ["Earthroot"] = {
        text = L["Earthroot"],
        path = "Interface\\Icons\\INV_Misc_Herb_07",
        width = 12,
        height = 12
    },
    ["Fadeleaf"] = {
        text = L["Fadeleaf"],
        path = "Interface\\Icons\\INV_Misc_Herb_12",
        width = 12,
        height = 12
    },
    ["Felweed"] = {
        text = L["Felweed"],
        path = "Interface\\Icons\\INV_Misc_Herb_Felweed",
        width = 12,
        height = 12
    },
    ["Firebloom"] = {
        text = L["Firebloom"],
        path = "Interface\\Icons\\INV_Misc_Herb_19",
        width = 12,
        height = 12
    },
    ["Goldthorn"] = {
        text = L["Goldthorn"],
        path = "Interface\\Icons\\INV_Misc_Herb_15",
        width = 12,
        height = 12
    },
    ["Grave Moss"] = {
        text = L["Grave Moss"],
        path = "Interface\\Icons\\INV_Misc_Dust_02",
        width = 12,
        height = 12
    },
    ["Gromsblood"] = {
        text = L["Gromsblood"],
        path = "Interface\\Icons\\INV_Misc_Herb_16",
        width = 12,
        height = 12
    },
    ["Icecap"] = {
        text = L["Icecap"],
        path = "Interface\\Icons\\INV_Misc_Herb_IceCap",
        width = 12,
        height = 12
    },
    ["Kingsblood"] = {
        text = L["Kingsblood"],
        path = "Interface\\Icons\\INV_Misc_Herb_03",
        width = 12,
        height = 12
    },
    ["Liferoot"] = {
        text = L["Liferoot"],
        path = "Interface\\Icons\\INV_Misc_Root_02",
        width = 12,
        height = 12
    },
    ["Mageroyal"] = {
        text = L["Mageroyal"],
        path = "Interface\\Icons\\INV_Jewelry_Talisman_03",
        width = 12,
        height = 12
    },
    ["Peacebloom"] = {
        text = L["Peacebloom"],
        path = "Interface\\Icons\\INV_Misc_Flower_02",
        width = 12,
        height = 12
    },
    ["Plaguebloom"] = {
        text = L["Plaguebloom"],
        path = "Interface\\Icons\\INV_Misc_Herb_PlagueBloom",
        width = 12,
        height = 12
    },
    ["Silverleaf"] = {
        text = L["Silverleaf"],
        path = "Interface\\Icons\\INV_Misc_Herb_10",
        width = 12,
        height = 12
    },
    ["Stranglekelp"] = {
        text = L["Stranglekelp"],
        path = "Interface\\Icons\\INV_Misc_Herb_11",
        width = 12,
        height = 12
    },
    ["Sungrass"] = {
        text = L["Sungrass"],
        path = "Interface\\Icons\\INV_Misc_Herb_18",
        width = 12,
        height = 12
    },
    ["Swiftthistle"] = {
        text = L["Swiftthistle"],
        path = "Interface\\Icons\\INV_Misc_Herb_04",
        width = 12,
        height = 12
    },
    ["Wildvine"] = {
        text = L["Wildvine"],
        path = "Interface\\Icons\\INV_Misc_Herb_03",
        width = 12,
        height = 12
    },
    ["Wintersbite"] = {
        text = L["Wintersbite"],
        path = "Interface\\Icons\\INV_Misc_Flower_03",
        width = 12,
        height = 12
    },
    ["Arthas' Tears"] = {
        text = L["Arthas' Tears"],
        path = "Interface\\Icons\\INV_Misc_Herb_13",
        width = 12,
        height = 12
    },
    ["Ghost Mushroom"] = {
        text = L["Ghost Mushroom"],
        path = "Interface\\Icons\\INV_Mushroom_08",
        width = 12,
        height = 12
    },
    ["Golden Sansam"] = {
        text = L["Golden Sansam"],
        path = "Interface\\Icons\\INV_Misc_Herb_SansamRoot",
        width = 12,
        height = 12
    },
    ["Khadgar's Whisker"] = {
        text = L["Khadgar's Whisker"],
        path = "Interface\\Icons\\INV_Misc_Herb_08",
        width = 12,
        height = 12
    },
    ["Mountain Silversage"] = {
        text = L["Mountain Silversage"],
        path = "Interface\\Icons\\INV_Misc_Herb_MountainSilverSage",
        width = 12,
        height = 12
    },
    ["Purple Lotus"] = {
        text = L["Purple Lotus"],
        path = "Interface\\Icons\\INV_Misc_Herb_17",
        width = 12,
        height = 12
    },
    ["Wild Steelbloom"] = {
        text = L["Wild Steelbloom"],
        path = "Interface\\Icons\\INV_Misc_Flower_01",
        width = 12,
        height = 12
    },
}

function mod:OnInitialize()
    local aceopts = AceAddon:GetAceOptionsDataTable(self)
    aceopts.toggle = {
        name  = AceLibrary('AceLocale-2.2'):new('Cartographer')['Toggle'],
        desc  = AceLibrary('AceLocale-2.2'):new('Cartographer')['Toggle the module on and off.'],
        type  = 'toggle',
        order = -1,
        get   = function() return Cartographer:IsModuleActive(self) end,
        set   = function() Cartographer:ToggleModuleActive(self) end,
    }

    Cartographer.options.args[bs["Herbalism"]] = {
        name = bs["Herbalism"],
        desc = self.notes,
        type = 'group',
        args = aceopts,
        handler = self,
    }
    Cartographer:GetModule('PinPoint').addons[bs["Herbalism"]] = self

    if not Cartographer_HerbalismDB then
        Cartographer_HerbalismDB = {}
    end

    if Cartographer_Notes then
        for k,v in pairs(self.icon) do
            Cartographer_Notes:RegisterIcon(k, v)
        end
    end
end

function mod:OnEnable()
    if Cartographer_Notes then
        Cartographer_Notes:RegisterNotesDatabase('Herbalism', Cartographer_HerbalismDB)
    else
        Cartographer:ToggleModuleActive(self, false)
    end

    self:RegisterEvent("UNIT_SPELLCAST_SENT")
    self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")
    self:RegisterEvent("UI_ERROR_MESSAGE")
end

function mod:OnDisable()
    self:UnregisterAllEvents()

    if Cartographer_Notes then
        Cartographer_Notes:UnregisterNotesDatabase('Herbalism')
    end
end

function mod:SetNote(what)
    local x, y = GetPlayerMapPosition("player")
    if x == 0 and y == 0 then return end
    local zone = GetRealZoneText()
    Cartographer_Notes:SetNote(zone, x, y, what, 0, 0.8, 0, "", 1, 1, 1, "", 1, 1, 1, "Herbalism", L:GetReverseTranslation(what))
end

function mod:CHAT_MSG_SPELL_SELF_BUFF(msg)
    local _,_,what = string.find(msg, string.format(L["^You perform %s on (.+)%%.$"], bs["Herb Gathering"]))
    if what then
        self:SetNote(what)
    end
end

function mod:UI_ERROR_MESSAGE(msg)
    if string.find(msg, UNIT_SKINNABLE_HERB) then
        local what = GameTooltipTextLeft1:GetText()
        if what and strlen(what) > 0 then
            self:SetNote(what)
        end
    end
end

function mod:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
    if spell == bs["Herb Gathering"] then
        local what = GameTooltipTextLeft1:GetText()
        if what and strlen(what) > 0 then
            self:SetNote(what)
        end
    end
end
